/*
 * Copyright (c) 1988 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * This file is formatted with tab stops every 8 columns.
 *
 * $Id: tty.c,v 1.2 1997/09/21 06:05:01 gdr Exp $
 */
 
#ifdef __ORCAC__
segment "libc_gen__";
#endif

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)ttyslot.c	5.6 (Berkeley) 2/23/91";
#endif /* LIBC_SCCS and not lint */

#include <sys/types.h>
#include <sys/stat.h>
#include <types.h>
#include <ttyent.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <gsos.h>

/*
 * gdr: ttyslot is probably buggy -- there is a search for '/' but
 * not for ':'
 */
 
int
ttyslot(void) {
	register struct ttyent *ttyp;
	register int slot;
	register char *p;
	int cnt;
	char *name;

	setttyent();
	for (cnt = 0; cnt < 3; ++cnt) 
		if (name = ttyname(cnt)) {
			if (p = rindex(name, '/')) 
				++p;
			else
				p = name;
			/*printf("p: %s\n",p);*/
                        for (slot = 1; ttyp = getttyent(); ++slot){
	                        /*printf("ty_name: %s\n",ttyp->ty_name);*/
				
                                if (!strcmp(ttyp->ty_name, p)) {
					endttyent();
					return(slot);
				}                                 }
			break;
		}
	endttyent();
	return(0);
}


char *
ttyname(int fino) {
	static ResultBuf32 resBuf;
	static RefInfoRecGS refInfo = {3,1,0,(ResultBuf255Ptr)&resBuf};

	if (!isatty(fino)) {
		return NULL;
	}
	resBuf.bufSize = 32;
	refInfo.refNum = fino;
	GetRefInfoGS(&refInfo);
	refInfo.pathname->bufString.text
		[refInfo.pathname->bufString.length] = 0;
	return refInfo.pathname->bufString.text;
}

int
isatty(int filedes) {
	struct stat sb;

	if (fstat(filedes,&sb) == -1) {
		return 0;
	} else if (sb.st_mode & S_IFCHR) {
		return 1;
	} else {
		return 0;
	}
}
